#ifndef __PARAMETERS_HPP
#define __PARAMETERS_HPP

// Various parameter definition

#define BGCOLOR                     SFXRGBColor(0, 0, 0, 0)         // Black background color
#define BALL_COLOR                  SFXRGBColor(255, 255, 255, 0)   // White ball
#define RACKET_COLOR                SFXRGBColor(255, 0, 0, 0)       // Red racket
#define MESSAGE_COLOR               SFXRGBColor(255, 255, 255, 0)   // White message color

#define BLOCK_H_NUM                 5                               // Maximum number of blocks (horizontal)
#define BLOCK_V_NUM                 6                               // Maximum number of blocks (vertical)

#define SPARE_BALLS                 2                               // Number of spare balls

#define RACKET_WIDTH2BLOCK_NUM      3                               // Racket width to block width (numerator)
#define RACKET_WIDTH2BLOCK_DEN      4                               // Racket width to block width (denominator)
#define RACKET_HEIGHT2BLOCK_NUM     1                               // Racket width to block height (numerator)
#define RACKET_HEIGHT2BLOCK_DEN     2                               // Racket width to block height (denominator)

#define RACKET_SPEED2BALL_NUM       16                              // Racket speed to ball speed (numerator)
#define RACKET_SPEED2BALL_DEN       10                              // Racket speed to ball speed (denominator)

#define RACKET_CORNER               4                               // Radius of the racket corners

#define TRAVEL_TIME                 1400                            // How many milliseconds would it take for a ball to
                                                                    // go from the bottom to the top
#define DRAW_RATE                   50                              // Redraw rate per second

#define BLOCK_MOVEMENT_TIME         10000                           // Time until block begins movement (unit millisecond)
#define BLOCK_MOVEMENT_INTERVAL     4000                            // Interval for block movement (unit millisecond)

#define BLOCK_TYPE_NONE             0                               // No block
#define BLOCK_TYPE_NORMAL           1                               // Standard block
#define BLOCK_TYPE_INVISIBLE        2                               // Invisible block

#define APP_STATUS_NOTHING          0                               // Do nothing
#define APP_STATUS_PLAYING          1                               // Playing game
#define APP_STATUS_READY            2                               // Waiting for user (when game begins)
#define APP_STATUS_WAIT_RESTART     3                               // Waiting for user (to restart)
#define APP_STATUS_CONTINUE         4                               // Continue at this stage
#define APP_STATUS_OPTIONS          5                               // Options menu
#define APP_STATUS_PAUSE            6                               // Options menu

#define STAGE_END_CONTINUE          0                               // Stage continue
#define STAGE_END_MISS              1                               // Game over
#define STAGE_END_CLEAR             2                               // Stage clear

#define MAX_STAGE                   4                               // Number of stages

#endif
